import os
import subprocess
import string
import Convert
import sys
realerror = False
ROMPos = [int(Convert.LoRomToPC("008000"),16)]
if len(sys.argv[1:]) != 3:
    base = raw_input("Base ROM\n")
    outro = raw_input("ROM to remove from\n")
    ASMFileName = raw_input("Patch to remove\n")
else:
    base = sys.argv[1]
    outro = sys.argv[2]
    ASMFileName = sys.argv[3]
temp = open("temp.asm", "w")
try:
    ASMFile = open(ASMFileName, "r")
except IOError:
    print "No such file: " + ASMFileName
    realerror = True
if not realerror:
    line = " "
    bank = 0
    while line != "":
        line = ASMFile.readline()
        line2 = line.split()
        if line != "":
            if len(line2) > 0:
                if string.lower(line2[0]) == "org":
                    temp.write("\nprint \"by\", bytes\n reset bytes\n")
                    temp.write(line)
                    temp.write("\nprint \"pc\", pc\n")
                else:
                    temp.write(line)
            else:
                temp.write(line)
        else:
            temp.write("\nprint \"by\", bytes\n reset bytes\n")
    temp.close()
    ASMFile.close()
    try:
        p = subprocess.Popen("xkas.exe temp.asm out.bin",stdout=subprocess.PIPE,stderr=subprocess.PIPE)
        out = p.communicate()[0]
        out = out.split("\r\n")
        out = out[:len(out)-1]
    except:
        realerror = True
        print "could not find xkas.exe"
    if not realerror:
        for i in range(len(out)):
            if out[i][:2] == "by":        
                out[i] = int(out[i][2:])
            elif out[i][:2] == "pc":
                ROMPos.append(int(Convert.LoRomToPC(out[i][2:]),16))
                out[i] = ""
            elif out[i][:6] == "error:":
                print "Error occured while assembling ASM file"
                realerror = True
                break
            else:
                out[i] = ""
        error = False
        while not error:
            try:
                out.remove('')
            except:
                error = True
        os.remove("out.bin")
        os.remove("temp.asm")

        if not realerror:
            try:
                baseROM = open(base,"rb")
            except IOError:
                print "No such file: " + base
                realerror = True
            try:
                outROM = open(outro,"r+b")
            except IOError:
                print "No such file: " + outro
                realerror = True
            if not realerror:
                basesize = os.path.getsize(base)
                for i in range(len(ROMPos)):
                    outROM.seek(ROMPos[i])
                    if ROMPos[i] < basesize:
                        baseROM.seek(ROMPos[i])
                        for j in range(out[i]):
                            byte = baseROM.read(1)
                            outROM.write(byte)
                    else:
                        for j in range(out[i]):
                            outROM.write("\x00")
                print "Patch successfully removed"
                outROM.close()
                baseROM.close()
